/*
Made by Daniel Kumor
Math plugin:
This plugin parses math tags, that is, it allows the tags:
[m]: auto-processed math, inline
[M]: very shiny centered auto-processed math
[t]: non-processed math
[T]: centered non-processed math
*/

var sciMath = {
	init:function() {
		//We need to modify the library a bit
		window.jsMath={
			Font:{Message: function() {}},	//The font message needs to be removed
			styles:{
			'#jsMath_button': {display: 'none'},
			'.jsM_Warning': {display: 'none'}
			}	//The panel button is not necessary
		}
		//Include the math library
		include("./math/jsMath.js");
		
	},
	parse:function(text) {
		text=text.replace(/\[m\]/g,"<div class='math'>");
		text=text.replace(/\[\/m\]/g,"</div>");
		return text;
	},
	run:function(obj) {
		jsMath.ProcessBeforeShowing(obj[0]);
	}
};
