/*
This script is (c) 2011 SciRoom, available under sciroom's license,
Made by Daniel Kumor
*/

//GLOBAL VARIABLES
var chat = [];	//The array where all the chat objects are stored
//Chat objects have the form:
//text - post content
//usr - the username
//unum - the user number
//pwd - the password hash
//date - the date

var updatelist = []; //The dictionary of things that need to be updated.
//It has the format:
//[number - action type, number, post number]

//The total amount of colors available in style for colorcoding
var colornum = 4;

//The time to set between update checks
var post_updatetime = 100;
var postnum=0;
var usrposts=0;


//Keys that are used for combos
var i_shiftpressed=0;
var i_prevshift=0
var i_enterpressed=0;
var i_preventer=0

//This allows to move up and down in text,useful for modifying what you said
var curpostloc=-1;
var savedtext="";

//Times
var time_updatetime=15000;

var notification_text='';
var notification_wait = 10000;


var textbox_addSize=34;
var textbox_checktype=180;
var textbox_checknum=0;


var scrollOffset=60;
var scrollDisabled=0;


function basicParse(text,skipbr) {
	text=text.replace(/</g,"&lt;");
	text=text.replace(/>/g,"&gt;");
	if (skipbr!=1)
		text=text.replace(/\n/g,"<br>");
	return text;
}
function Parse(text) {
	text=basicParse(text);
	text=text.replace(/\[m\]/g,"<div class='math'>");
	text=text.replace(/\[\/m\]/g,"</div>");
	text=text.replace(/\[c\]/g,"<pre class='prettyprint'>");
	text=text.replace(/\[\/c\]/g,"</pre>");
	return text;
}

/*
The initializer funtion. This here function is run to set the chat up, and 
to get ready to get shit done!
*/

function room_init() {
	
	//We first include jQuery. It should become available after the document
	//	finishes loading
	if (typeof jQuery == 'undefined') {
		include("./code/jquery.js");
	}
	
	//Next, we need to include the most important element! jsMath!
	include("./math/jsMath.js");
	//After that, the next element of importance: Code highlighting!
	include("./codehighlight/prettify.js");
	include_style("./codehighlight/prettify.css");
	
	//Next, we load the default chatstyle, since it is the only one for now
	include_style("./styles/chatstyle.css");
	
	//After the document finishes loading, we can set functions
	window.onload=docloaded;
	//The reason we don't do that now, is that if the user somehow clicks
	//	something before the document is loaded, then javascript functions
	//	that require jQuery or other stuff will not work.
}

//Here, we bind all the functions, and then load data from server.
function docloaded() {
	if (typeof jQuery == 'undefined') {
		asplode("jQuery failed to load!");
	}
	notify("Preparing...");
	//Okay, now we can bind everything to everything else.
	$("#postbutton").click(post);
	
	$("#inputtext").keydown(inputdn).keyup(inputup).bind("paste",function(e){window.setTimeout(resizetextbox,40);});
	
	//Make sure the user can scroll through this stuff without problems
	$(window).scroll(scrollfnc);
	//The text area initializers
	textinit();
	
	//The post updater will now work
	updateposts();
	checktimes();
	
	notify("Loading data from server...");
}
function scrollfnc() {
	if ($(window).scrollTop() + $(window).height() >= $(document).height()) {
		scrollDisabled=0;
	} else {
		scrollDisabled=1;
	}
}
function textinit() {//This is one of the most unusual workarounds for automatically finding textarea stuffs..
	//We can't find out how much text there really is! that is annoying, but we have a solution
	//http://michaux.ca/articles/automatically-expanding-textarea-elements-with-yahoo-ui
	
	//This can also be used for live preview of posts! ballin!
	$("#chatInput").append("<div id='textlength_area' style='width:99%; display:none; font:"+$("#inputtext").css("font")+"'></div>");
}

function resizetextbox(q) {
	$("#textlength_area").html(basicParse($("#inputtext").val()));
	tbsize= parseInt($("#textlength_area").css("height").replace("px",""));
	if (scrollDisabled==0)
		scrolldown();
	
	//Don't lower the textbox size unless actually have to
	if (parseInt($("#inputtext").css("height").replace('px',''))<textbox_addSize+tbsize || q==1)
	$("#inputtext").animate({height: (textbox_addSize+tbsize)+"px"},200);
}

/*
	EVENT HANDLERS
*/
function post() {
	//Just so that we don't have nameless posters
	if ($("#usr").val()=='') $("#usr").val("Anonymous");
	if ($("#inputtext").val()!=''){
		chat.push({text: $("#inputtext").val(),usr:$("#usr").val(),unum:1,pwd:$("#pwd").val(),date:(new Date()).getTime()});
		$("#inputtext").val("").focus();
	} else {
		notify("You didn't write anything!");
	}
	resizetextbox(1);
	scrolldown();
	//The current post location needs to be fixed
	//curpostloc=-1; It is updated in the key event itself
}




/*TIMED ACTIONS*/

function notify(text,type) {
	if (type==1) {
		notification_text=text;
		notify_reset();
	} else if (type==2) {
		text="<span style='color:red'>"+text+"</span>";
		$("#postinfo").html(text);
	} 
	else {
		$("#postinfo").html(text);
		window.setTimeout(notify_reset,notification_wait);
	}
}
function notify_reset() {
	$("#postinfo").text(notification_text);
}
//This is the function where everything happens.
function updateposts() {
	var i=0;
	var scroll=0;
	if (postnum<chat.length){
		scroll=1;
		while (postnum<chat.length) {
			addPost(postnum);
			postnum++;
		}
	}
	while (i<updatelist.length) {
		switch(updatelist[i][0]) {
			case 1:
				$(".chat_date:eq("+updatelist[i][1]+")").text(updatelist[i][2]);
				break;	//Ignore unrecognized
			default:
				break;	//Ignore unrecognized
		}
		i++;
	}
	updatelist = [];
	window.setTimeout(updateposts,post_updatetime);
	if (scrollDisabled==0 && scroll==1)
		scrolldown();
}
function scrolldown() {
	window.setTimeout(function(){$('html, body').animate({scrollTop: document.body.scrollHeight+"px"},30);},70);
}
//Modify a post that already exists
function modPost(postnum,what) {
	
}

function post_postedit(cnum) {
	jsMath.ProcessBeforeShowing($("#chatmsgs .chat_content")[cnum]);
	var pobj = $(".chat_content:eq("+cnum+")").find(".prettyprint")
	pobj.each(function(index){$(this).html(prettyPrintOne($(this).html()))});
	
	//each(function(index){notify("YEE");$(this).HTML(prettyPrintOne($(this).HTML()));});
}

function addPost(cnum) {
	//http://www.math.union.edu/~dpvc/jsMath/authors/dynamic.html
	//We have the chat number, so make the post!
	var c = chat[cnum];
	posttext = '<div class="chat_content" id="cc1" style="display:none"><div class="chat_date">'+prettytime(c.date)+'</div>'+Parse(c.text)+'</div>';
	if (cnum==0 || chat[cnum-1].unum!=c.unum) {
		//We now add the user stuff
		posttext='<div class="chat p'+(c.unum%colornum)+'_color" style="display:none"><div class="chat_pwdid">'+basicParse(c.pwd,1)+'</div><div class="chat_name">'+basicParse(c.usr,1)+'</div>'+posttext+'</div>';
		$("#chatmsgs").append(posttext);
		$(".chat_content:last").slideToggle(0);
		$(".chat:last").slideToggle(120);
		usrposts++;
	} else {
		//We add on the post to the end of the last one
		$("#chatmsgs .chat:last").append(posttext);
		$(".chat_content:last").slideToggle(70);
	}
	post_postedit(cnum);
}

//38^ 40 down
function inputup(event) {
	setvalue=0;
	check=0;
	if (event.keyCode == '13') {
		i_preventer=i_enterpressed;
		i_enterpressed=setvalue;
		if (i_preventer != i_enterpressed)
			check=1;
	}
	if (event.keyCode == '16') {
		i_prevshift=i_shiftpressed;
		i_shiftpressed=setvalue;
		if (i_prevshift != i_shiftpressed)
			check=1;
	}
	if (check)
		i_keyCheck();
		
	//Now we check whether we should resize the textbox
	textbox_checknum++;
	if (textbox_checknum>=textbox_checktype) {
		textbox_checknum=0;
		resizetextbox();
	}
}
function inputdn(event) {
	setvalue=1;
	check=0;
	if (event.keyCode == '13') {
		i_preventer=i_enterpressed;
		i_enterpressed=setvalue;
		if (i_preventer != i_enterpressed)
			check=1;
	}
	if (event.keyCode == '16') {
		i_prevshift=i_shiftpressed;
		i_shiftpressed=setvalue;
		if (i_prevshift != i_shiftpressed)
			check=1;
	}
	if (check)
		i_keyCheck(event);
	
	if (event.keyCode==9) {
		event.preventDefault();
		insertTab();
	}
	
	//Now, we check for the up and down keys, so that the author can click up key for previous post text
	if (event.keyCode == '38') {
		event.preventDefault();
		if (curpostloc==-1) {
			curpostloc=chat.length;
			savedtext=$("#inputtext").val();
		}
		if (curpostloc != 0) {
			curpostloc--;
			$("#inputtext").val(chat[curpostloc].text);
		}
	} else if (event.keyCode == '40') {
		event.preventDefault();
		if (curpostloc!=-1) {
			curpostloc++;
			if (curpostloc==chat.length) {
				curpostloc=-1;
				$("#inputtext").val(savedtext);
			} else {
				$("#inputtext").val(chat[curpostloc].text);
			}
		}
	} else {
		curpostloc=-1;
	}
}

function instertTab() {
	
}

//Checks key combinations
function i_keyCheck(event) {
	if (i_shiftpressed && i_enterpressed)
		i_shiftenter(event);
	else if (i_enterpressed)
		i_enter(event);
}

function i_shiftenter(event) {
	//We add a line to the textbox,so that it is all visible - if the textbox needs the line only!
	resizetextbox();
}
function i_enter(event) {
	post();
	event.preventDefault();
}

function checktimes() {
	var i=0;
	while (i< chat.length) {
		updatelist.push([1,i,prettytime(chat[i].date)]);
		i++;
	}	
	window.setTimeout(checktimes,time_updatetime);
}

//Makes the dates and times look pretty
function prettytime(time) {
	var diff = (new Date()).getTime() - time;
	if (diff < 1000) return "just now";
	diff=Math.round(diff/1000);
	if (diff < 2) return "a second ago";
	if (diff>10)
		diff=10*Math.round(diff/10);
	if (diff < 60) return diff +" seconds ago";
	diff = Math.round(diff/60);
	if (diff < 2) return "a minute ago";
	if (diff < 60) return diff + " minutes ago";
	diff = Math.round(diff/60);
	if (diff <2) return "an hour ago";
	if (diff <24) return diff + " hours ago";
	diff=Math.round(diff/24);
	if (diff <2) return "Yesterday";
	if (diff <7) return diff + " days ago";
	diff=Math.round(diff/7);
	if (diff < 2) return "a week ago";
	return diff + " weeks ago";
	
}

//Does just that, tells the user there is a problem.
function asplode(err) {
	alert("SciRoom EXPLODED! Error: "+ err + "\nThe room is now unstable...");
}

/*
Random functions. These allow the inclusion of script/style files without putting them in the header directly
*/
function include(scriptsrc) {
	var html_doc = document.getElementsByTagName('head').item(0)	;
    var js = document.createElement('script')						;
	js.setAttribute('language', 'javascript')						;
	js.setAttribute('type', 'text/javascript')						;
	js.setAttribute('src', scriptsrc)								;
	html_doc.appendChild(js)										;
}
function include_style(stylesrc) {
	var html_doc = document.getElementsByTagName('head').item(0)	;
    var js = document.createElement('link')							;
	js.setAttribute('rel', 'stylesheet')							;
	js.setAttribute('type', 'text/css')								;
	js.setAttribute('href', stylesrc)								;
	html_doc.appendChild(js)										;
}

