/*
This code originates from Ted Devito's tabby jquery plugin. It was simplified to work well with sciroom.
Also, the code was fixed in a couple areas. I have deleted the IE implementation, since hopefully the
new IE won't suck
*/

/*
 *	Tabby jQuery plugin version 0.12
 *
 *	Ted Devito - http://teddevito.com/demos/textarea.html
 *
 *	Copyright (c) 2009 Ted Devito
 *	 
 *	Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following 
 *	conditions are met:
 *	
 *		1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 *		2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer  
 *			in the documentation and/or other materials provided with the distribution.
 *		3. The name of the author may not be used to endorse or promote products derived from this software without specific prior written 
 *			permission. 
 *	 
 *	THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 *	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE 
 *	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 *	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
 *	OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
var tabby = {

	tabstring: String.fromCharCode(9),			//The character used for putting in tabs
	tablist:[String.fromCharCode(9),'    '],	//The strings that look like tabs to it
	
	tab: function(o,detab) {			//Accepts the jQuery textArea object, and a boolean whether it is to untab
		var scrollTo = o.scrollTop;
		
		//IE support is a bitch
		if (o.setSelectionRange) this.std_tab(o,detab);
		else if (document.selection) ie_tab(o,detab);
		
		o.scrollTop = scrollTo;
	},
	std_tab: function(o,detab) {
		var ss = o.selectionStart;
		var se = o.selectionEnd;
		
		//There is no selection, add/remove tabs at caret
		if (ss==se) {
			if (detab) {
				var detabbed=false;
				var i=0;
				for (i=0;i<this.tablist.length && !detabbed;i++) {//First check the left hand
					if (this.tablist[i]==o.value.substring(ss-this.tablist[i].length,ss)) {
						o.value=o.value.substring(0,ss-this.tablist[i].length)+o.value.substring(ss);
						//o.focus();//Necessary?
						o.setSelectionRange(ss-this.tablist[i].length,ss-this.tablist[i].length);
						detabbed=true;
					}
				}
				for (i=0;i<this.tablist.length && !detabbed;i++) {//Then check the right hand
					if (this.tablist[i]==o.value.substring(ss,ss+this.tablist[i].length)) {
						o.value=o.value.substring(0,ss)+o.value.substring(ss+this.tablist[i].length);
						//o.focus();//Necessary?
						o.setSelectionRange(ss,ss);
						detabbed=true;
					}
				}
			} else {	//If tab
				o.value=o.value.substring(0,ss)+this.tabstring+o.value.substring(ss);
				o.setSelectionRange(ss+this.tabstring.length,ss+this.tabstring.length);
			}
		} else {//Aww shit, there is a selection
			//Sometimes the selection is incomplete, we must therefore include the previous \n
			var preline = o.value.substring(0,ss).lastIndexOf('\n');
			var sf=ss;
			var addsel=0;
			if (preline != -1 && o.value.charAt(ss)!='\n')
				sf=	preline+1;
			
			var lines = o.value.substring(sf,se).split('\n');
			var totaltext='';
			var i=0;
			
			if (detab) {				
				for (var z in lines) {
					detabbed=false;
					for (i=0;i<this.tablist.length && !detabbed;i++) {//Then check the right hand
						if (this.tablist[i]==lines[z].substring(0,this.tablist[i].length)) {
							lines[z]=lines[z].substring(this.tablist[i].length);
							detabbed=true;
							if (z==0) addsel= -this.tablist[i].length;
								
						}
					}
				}
			} else {//If tab
				for (var i in lines) {
					lines[i]=this.tabstring+lines[i];
					if (i==0) addsel=this.tabstring.length;
				}
			}
			
			for (i=0;i<lines.length-1;i++){
				totaltext+=lines[i]+'\n';
			}
			totaltext+=lines[lines.length-1];
			
			o.value=o.value.substring(0,sf)+totaltext+o.value.substring(se);
			o.setSelectionRange(ss+addsel,ss+totaltext.length+addsel);
		}
		
	},
	ie_tab:function(obj,detab) {
		//Quite frankly, if you are using an oldversion of IE, then you probably won't need tabs anyways...
	}
}
